// ----------------------------------------
// Диалоговая панель со списком COMBOBOX
// ----------------------------------------

#define STRICT
#include <windows.h>
#include <mem.h>
#include "dlgcombo.hpp"

#define IDB_Button1 1

// Прототипы функций
BOOL InitApp(HINSTANCE);
LRESULT CALLBACK _export WndProc(HWND, UINT, WPARAM, LPARAM);
BOOL    CALLBACK _export DlgProc(HWND, UINT, WPARAM, LPARAM);

// Имя класса окна
char const szClassName[]   = "DialogAppClass";

// Заголовок окна
char const szWindowTitle[] = "Dialog Box Demo";

HINSTANCE hInst;

// =====================================
// Функция WinMain
// =====================================
#pragma argsused

int PASCAL
WinMain(HINSTANCE hInstance,
	HINSTANCE hPrevInstance,
	LPSTR     lpszCmdLine, 
	int       nCmdShow)   
{
  MSG  msg;   // структура для работы с сообщениями
  HWND hwnd;  // идентификатор главного окна приложения

  HWND hButton1;

  // Инициализируем приложение
  if(!InitApp(hInstance))
      return FALSE;

  hInst = hInstance;

  // После успешной инициализации приложения создаем
  // главное окно приложения
  hwnd = CreateWindow(
    szClassName,         // имя класса окна
    szWindowTitle,       // заголовок окна
    WS_OVERLAPPEDWINDOW, // стиль окна
    CW_USEDEFAULT,       // задаем размеры и расположение
    CW_USEDEFAULT,       // окна, принятые по умолчанию 
    CW_USEDEFAULT,
    CW_USEDEFAULT,
    0,                   // идентификатор родительского окна
    0,                   // идентификатор меню
    hInstance,           // идентификатор приложения
    NULL);               // указатель на дополнительные
			 // параметры

  // Если создать окно не удалось, завершаем приложение
  if(!hwnd)
    return FALSE;

  // Рисуем главное окно
  ShowWindow(hwnd, nCmdShow);
  UpdateWindow(hwnd);

  // Создаем кнопку
  hButton1 = CreateWindow("button", "Open...",
    WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
    20, 20,
    90, 30,
    hwnd,
    (HMENU) IDB_Button1,
    hInstance, NULL);

  // Запускаем цикл обработки сообщений
  while(GetMessage(&msg, 0, 0, 0))
  {
    DispatchMessage(&msg);
  }
  return msg.wParam;
}

// =====================================
// Функция InitApp
// Выполняет регистрацию класса окна
// =====================================

BOOL
InitApp(HINSTANCE hInstance)
{
  ATOM aWndClass; // атом для кода возврата
  WNDCLASS wc;    // структура для регистрации
                  // класса окна

  memset(&wc, 0, sizeof(wc));

  wc.style = 0;
  wc.lpfnWndProc = (WNDPROC) WndProc;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 0;
  wc.hInstance = hInstance;
  wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
  wc.lpszMenuName = (LPSTR)NULL;
  wc.lpszClassName = (LPSTR)szClassName;

  // Регистрация класса
  aWndClass = RegisterClass(&wc);

  return (aWndClass != 0);
}

// =====================================
// Функция WndProc
// =====================================

LRESULT CALLBACK _export
WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  switch (msg)
  {
    case WM_COMMAND:
    {
      // Если нажата кнопка, выводим
      // диалоговую панель
      if(wParam == IDB_Button1)
      {
        // Создаем модальную диалоговую панель
        DialogBox(hInst, "SELECT_FILE", hwnd, (DLGPROC)DlgProc);
      }
      return 0;
    }

    case WM_DESTROY:
    {
      PostQuitMessage(0);
      return 0;
    }
  }
  return DefWindowProc(hwnd, msg, wParam, lParam);
}

// =====================================
// Функция DldProc
// =====================================
#pragma argsused

BOOL CALLBACK _export
DlgProc(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
  switch(msg)
  {
    // Инициализация диалоговой панели
    case WM_INITDIALOG:
    {
      // Заполняем список именами файлов, каталогов
      // и дисковых устройств
      DlgDirListComboBox(hdlg,
        "*.*", IDC_COMBO, IDC_STATIC,
        DDL_READWRITE | DDL_READONLY  | DDL_HIDDEN |
        DDL_SYSTEM    | DDL_DIRECTORY | DDL_DRIVES |
        DDL_ARCHIVE);

      return TRUE;
    }

    case WM_COMMAND:
    {
      switch(wParam)
      {
        char Buffer[80];

        // Обрабатываем извещение от списка
        case IDC_COMBO:
        {
          // Двойной щелчок мышью по строке списка
          if(HIWORD(lParam) == LBN_DBLCLK)
          {
            // Получаем выбранную строку
            // и отображаем ее на экране
            GetDlgItemText(hdlg, IDC_COMBO, Buffer, 80);
            MessageBox(hdlg, Buffer, szWindowTitle, MB_OK);
          }
          return TRUE;
        }

        // Сообщение от кнопки "OK"
        case IDOK:
        {
          // Получаем выбранную строку
          // и отображаем ее на экране
          GetDlgItemText(hdlg, IDC_COMBO, Buffer, 80);
          MessageBox(hdlg, Buffer, szWindowTitle, MB_OK);
          return TRUE;
        }

        // Отмена диалоговой панели.
        case IDCANCEL:
        {
          // Устанавливаем флаг завершения диалога
          EndDialog(hdlg, 0);
          return TRUE;
        }
      }
    }
  }
  return FALSE;
}
